/*
 *	System Dependent Application Message Handling
 *	Net Bios
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this program is strictly prohibited.
 *
 *      Copyright (c) 1987, 1988, 1989 FairCom Corporation
 *	(Subject to limited distribution and
 *	 restricted disclosure only.)
 *	*** ALL RIGHTS RESERVED ***
 *
 *	4006 West Broadway
 *	Columbia, MO 65203
 *
 *
 *	c-tree(R)	Version 4.3
 *			Release C
 *			February 7, 1989 17:30
 *
 */

#define CBRK_NONE	0	/* do nothing about ctrl-c */
#define CBRK_DFL	1	/* abort on ctl-c */
#define CBRK_IGN	2	/* ignore ctl-c */

#define CERR_NONE	0	/* do nothing about critical errors */
#define CERR_DFL	1	/* use standard ignore,abort,retry prompts */
#define CERR_FAIL	2	/* fail the dos call */


/* set traps on abnormal terminations */
/* 1st arg is mode for int 23 (control-c) ... CBRK_xxx */
/* 2nd is mode for int 24 (hard err) ... CERR_xxx */
void far set_abort_traps(COUNT,COUNT);

/*
 * define what system should do with a control-C (interrupt 23)
 * _NONE == don't trap, _DFL == clean up and abort, _IGN == ignore ctrl-c
 */

#define CBRKmode CBRK_DFL	/* ctl-c causes call to STPUSR, then abort */

/*
 * define what system should do when abort on critical error (interrupt 24)
 * _NONE == don't trap, _DFL == display user prompt and clean up/abort if
 * user selects abort, _FAIL == return DOS error 0x83 on critical errors
 */

#define CERRmode CERR_DFL	/* error abort calls STPUSR, then abort */

/* end of ctaxit.h */
