######################################################################
# Make applications library for c-tree application library
# Invoke with MAKEAPPX.BAT
#
# For PC LAN file server extension version.
#
######################################################################

##################
# default macros #
##################

# rtree directory
RTREE=..\..\rtree

# c compiler
COMPILER=cl /c

# assembler
ASM=masm

# c compiler model switch
CM=/AS

# assemble model define
AM=SMALL

# obj/exe/lib directory
D=SAPP

#c compile include path
P=/I .\ /I ..\ /I ..\msc /I $(RTREE)

#linker name
LINK=link

#library name
LN=ctalib

#full library name
ALIB=$(LN).lib

#linker object file list
MSG=+ctamsgx+ctamsgxa+ctnbios+ctaxit/m

#make exe's dependency list
DMSG=$(D)\ctamsgx.obj $(D)\ctamsgxa.obj $(D)\ctnbios.obj $(D)\ctaxit.obj

################################
# complile all library modules #
################################

$(D)\ctappx.obj: ..\ctappx.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx2.obj: ..\ctapx2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx3.obj: ..\ctapx3.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx4.obj: ..\ctapx4.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctsset.obj: ..\ctsset.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctisam.obj: ..\ctisam.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrec.obj: ..\ctvrec.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrcu.obj: ..\ctvrcu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctestm.obj: ..\ctestm.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctism2.obj: ..\ctism2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismc.obj: ..\ctismc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismo.obj: ..\ctismo.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\cticre.obj: ..\cticre.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctiopn.obj: ..\ctiopn.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctcomp.obj: ..\ctcomp.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\cticls.obj: ..\cticls.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctifil.obj: ..\ctifil.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismu.obj: ..\ctismu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctclb2.obj: ..\ctclb2.c    # low level disk interface
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

#####################
# build the library #
#####################

$(D)\$(ALIB): $(D)\ctappx.obj $(D)\ctapx2.obj $(D)\ctapx3.obj $(D)\ctapx4.obj \
			$(D)\ctsset.obj $(D)\ctisam.obj $(D)\ctvrec.obj \
			$(D)\ctvrcu.obj $(D)\ctism2.obj $(D)\ctestm.obj \
			$(D)\ctismc.obj $(D)\ctismo.obj $(D)\cticre.obj \
			$(D)\ctiopn.obj $(D)\ctcomp.obj \
			$(D)\cticls.obj $(D)\ctifil.obj \
			$(D)\ctismu.obj $(D)\ctclb2.obj
	cd $(D)
	if exist $(LN).bak del $(LN).bak
	if exist $(ALIB) ren $(ALIB) $(LN).bak
	echo $(ALIB) > lrsp
	echo y >> lrsp
	echo +ctappx+ctapx2 & >> lrsp
	echo +ctsset+ctisam+ctvrec+ctvrcu+ctism2 & >> lrsp
	echo +ctismc+ctismo+cticre+ctestm & >> lrsp
	echo +ctiopn+ctcomp & >> lrsp
	echo +cticls+ctifil & >> lrsp
	echo +ctismu+ctapx3+ctapx4 & >> lrsp
	echo +ctclb2 >> lrsp
	echo $(LN).m >> lrsp
	echo $(ALIB) >> lrsp
	lib @lrsp
	del lrsp
	cd ..

#######################################
# compile environment dependent files #
#######################################

$(D)\ctamsgx.obj: ctamsgx.c ctaxit.h
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctamsgxa.obj: ctamsgxa.asm
	$(ASM) $*/ml/D$(AM);
	copy $*.obj $(D)\*.*
	del $*.obj

$(D)\ctnbios.obj: ctnbios.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctaxit.obj: ctaxit.asm
	$(ASM) $*/ml/D$(AM);
	copy $*.obj $(D)\*.*
	del $*.obj

####################################
# compile/link server stop utility #
# CTSTOPX                          #
####################################

$(D)\ctstop.obj: ..\ctstop.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctstopx.exe: $(D)\ctstop.obj $(DMSG) $(D)\ctclb2.obj
	cd $(D)
	$(LINK) ctstop$(MSG)+ctclb2,ctstopx;
	cd ..

####################################
# compile/link server stat utility #
# CTSTATX                          #
####################################

$(D)\ctstat.obj: ..\ctstat.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctstatx.exe: $(D)\ctstat.obj $(DMSG) $(D)\ctclb2.obj
	cd $(D)
	$(LINK) ctstat$(MSG)+ctclb2,ctstatx;
	cd ..

###################################
# compile/link example programs   #
# CTEXMCX CTEXMGX CTVXMGX CTIXMGX #
###################################

$(D)\ctexmc.obj: ..\ctexmc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctexmcx.exe: $(D)\ctexmc.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctexmc$(MSG),ctexmcx,,$(LN);
	cd ..

$(D)\ctexmg.obj: ..\ctexmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctexmgx.exe: $(D)\ctexmg.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctexmg$(MSG),ctexmgx,,$(LN);
	cd ..

$(D)\ctvxmg.obj: ..\ctvxmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvxmgx.exe: $(D)\ctvxmg.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctvxmg$(MSG),ctvxmgx,,$(ALIB);
	cd ..

$(D)\ctixmg.obj: ..\ctixmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctixmgx.exe: $(D)\ctixmg.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctixmg$(MSG),ctixmgx,,$(ALIB);
	cd ..

