######################################################################
# Make library for c-tree server and make ctsrvr.exe and ctsrvrfg.exe
# Invoke with MAKESRV.BAT
#
# For NET BIOS server version.
#
######################################################################


##################
# default macros #
##################

# c compiler
COMPILER=cl /c

# assembler
ASM=masm

# c compiler model switch
CM=/AS

# assemble model define
AM=SMALL

# obj/exe/lib directory
D=SSRV

#c compile include path
P=/I .\ /I ..\ /I ..\msc

#linker name
LINK=link

#library name
LN=ctslib

#full library name
SLIB=$(LN).lib


################################
# complile all library modules #
################################


$(D)\ctvrc2.obj: ..\ctvrc2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctdelk.obj: ..\ctdelk.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctaddk.obj: ..\ctaddk.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctupdt.obj: ..\ctupdt.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctsrch.obj: ..\ctsrch.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctfrac.obj: ..\ctfrac.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctdatf.obj: ..\ctdatf.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctkeyf.obj: ..\ctkeyf.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctkrnl.obj: ..\ctkrnl.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctclb3.obj: ..\ctclb3.c
	$(COMPILER) /Gs $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctcomp.obj: ..\ctcomp.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrcu.obj: ..\ctvrcu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctinit.obj: ..\ctinit.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctdelf.obj: ..\ctdelf.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctclb2.obj: ..\ctclb2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctclib.obj: ..\msc\ctclib.c
	copy ..\msc\ctoptn.h ..\msc\ctoptn.sav
	del ..\msc\ctoptn.h
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\msc\$*.c
	copy ..\msc\ctoptn.sav ..\msc\ctoptn.h

$(D)\ctslok.obj: ..\ctslok.c    # low level disk interface
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctrfio.obj: ctrfio.c    # low level disk interface
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctsrve.obj: ..\ctsrve.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctsprtf.obj: ctsprtf.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctfulnam.obj: ctfulnam.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

#####################
# build the library #
#####################

$(D)\$(SLIB): $(D)\ctvrc2.obj \
			$(D)\ctsrve.obj $(D)\ctsprtf.obj $(D)\ctfulnam.obj \
			$(D)\ctdelk.obj $(D)\ctaddk.obj $(D)\ctupdt.obj \
			$(D)\ctfrac.obj \
			$(D)\ctsrch.obj $(D)\ctdatf.obj $(D)\ctkeyf.obj \
			$(D)\ctkrnl.obj $(D)\ctcomp.obj $(D)\ctvrcu.obj \
			$(D)\ctinit.obj $(D)\ctdelf.obj $(D)\ctclb2.obj \
			$(D)\ctslok.obj $(D)\ctclib.obj $(D)\ctclb3.obj \
			$(D)\ctrfio.obj
	cd $(D)
	del $(LN).bak
	ren $(SLIB) $(LN).bak
	echo $(SLIB) > lrsp
	echo y >> lrsp
	echo +ctvrc2+ctsrve+ctsprtf+ctfulnam & >> lrsp
	echo +ctdelk+ctaddk+ctupdt & >> lrsp
	echo +ctfrac+ctsrch+ctdatf & >> lrsp
	echo +ctkeyf+ctkrnl+ctcomp+ctvrcu & >> lrsp
	echo +ctinit+ctdelf+ctclb2+ctslok+ctclib+ctclb3+ctrfio >> lrsp
	echo $(LN).m >> lrsp
	echo $(SLIB) >> lrsp
	lib @lrsp
	del lrsp
	cd ..

##################################
# compile environment dependent  #
# files for non-dedicated server #
##################################

$(D)\ctsrvr.obj: ..\ctsrvr.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctsmsg.obj: ctsmsg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctnbios.obj: ctnbios.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctstsr.obj: ctstsr.asm
	$(ASM) $*/ml/D$(AM);
	copy $*.obj $(D)\*.*
	del $*.obj

#############################
# link non-dedicated server #
#############################

$(D)\ctsrvr.exe: $(D)\ctsrvr.obj $(D)\ctsmsg.obj \
			$(D)\ctnbios.obj $(D)\ctstsr.obj $(D)\$(SLIB)
	cd $(D)
	$(LINK) ctsrvr+ctsmsg+ctnbios+ctstsr/m /NOE $(CP),,,$(LN);
	cd ..

##################################
# compile environment dependent  #
# files for dedicated server     #
##################################

$(D)\ctsmsgfg.obj: ctsmsg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) /DFOREGROUND ctsmsg.c

$(D)\ctsfg.obj: ctsfg.asm
	$(ASM) $*/ml/D$(AM);
	copy $*.obj $(D)\*.*
	del $*.obj

#############################
# link non-dedicated server #
#############################

$(D)\ctsrvrfg.exe: $(D)\ctsrvr.obj $(D)\ctsmsgfg.obj \
			$(D)\ctnbios.obj $(D)\ctsfg.obj $(D)\$(SLIB)
	cd $(D)
	$(LINK) ctsrvr+ctsmsgfg+ctnbios+ctsfg/m /NOE $(CP),ctsrvrfg,ctsrvrfg,$(LN);
	cd ..

